import React from 'react';
import { VariableSizeList as List } from 'react-window';
export type ItemRenderer<T> = (item: T, ref: React.Ref<HTMLDivElement>, index: number) => React.ReactNode;
export type VirtualListRef = React.MutableRefObject<List | null>;
export type VirtualListProps<T> = {
    items: T[];
    renderItem: ItemRenderer<T>;
    estimateItemInitialHeight(item: T): number;
    overScanCount?: number;
    rowGap?: number;
    listOuterContainerClassName?: string;
    dataTestId?: string;
    itemDataTestId?: string;
    initialScrollTop?: number;
    scrollableContainerRef?: React.Ref<HTMLDivElement>;
    __TEST_LIST_WIDTH?: number;
    __TEST_LIST_HEIGHT?: number;
    __TEST_LIST_REF?: VirtualListRef;
};
export declare function VirtualList<T>({ items, estimateItemInitialHeight, renderItem, overScanCount, rowGap, listOuterContainerClassName, dataTestId, itemDataTestId, initialScrollTop, scrollableContainerRef, __TEST_LIST_WIDTH, __TEST_LIST_HEIGHT, __TEST_LIST_REF, }: VirtualListProps<T>): JSX.Element;
//# sourceMappingURL=virtual-list.d.ts.map