"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VirtualList = void 0;
const react_1 = __importStar(require("react"));
const react_window_1 = require("react-window");
const react_virtualized_auto_sizer_1 = __importDefault(require("react-virtualized-auto-sizer"));
const emotion_1 = require("@leafygreen-ui/emotion");
const use_virtual_list_item_observer_1 = require("../hooks/use-virtual-list-item-observer");
const flexContainerStyles = (0, emotion_1.css)({
    width: '100%',
    height: '100%',
    position: 'relative',
    display: 'flex',
    overflow: 'hidden',
});
const flexItemStyles = (0, emotion_1.css)({
    flex: 1,
});
function VirtualList({ items, estimateItemInitialHeight, renderItem, overScanCount, rowGap, listOuterContainerClassName, dataTestId, itemDataTestId, initialScrollTop, scrollableContainerRef, __TEST_LIST_WIDTH = 1024, __TEST_LIST_HEIGHT = 768, __TEST_LIST_REF, }) {
    const listRef = (0, react_1.useRef)(null);
    const inUseListRef = __TEST_LIST_REF ?? listRef;
    const { observer, estimatedItemSize, getItemSize } = (0, use_virtual_list_item_observer_1.useVirtualListItemObserver)({
        listRef: inUseListRef,
        rowGap,
        items,
        estimateItemInitialHeight,
    });
    const itemData = (0, react_1.useMemo)(() => ({
        items,
        observer,
        itemDataTestId,
        renderItem,
    }), [items, observer, itemDataTestId, renderItem]);
    const isTestEnv = process.env.NODE_ENV === 'test';
    return (react_1.default.createElement("div", { className: flexContainerStyles, "data-testid": dataTestId },
        react_1.default.createElement("div", { className: flexItemStyles },
            react_1.default.createElement(react_virtualized_auto_sizer_1.default, { disableWidth: isTestEnv, disableHeight: isTestEnv }, ({ width, height }) => (react_1.default.createElement(react_window_1.VariableSizeList, { ref: inUseListRef, width: isTestEnv ? __TEST_LIST_WIDTH : width, height: isTestEnv ? __TEST_LIST_HEIGHT : height, itemData: itemData, itemCount: items.length, estimatedItemSize: estimatedItemSize, itemSize: getItemSize, overscanCount: overScanCount, initialScrollOffset: initialScrollTop, outerRef: scrollableContainerRef, innerElementType: InnerElementType, className: listOuterContainerClassName }, DocumentRow))))));
}
exports.VirtualList = VirtualList;
function DocumentRow({ index, style, data, }) {
    const itemRef = (0, react_1.useRef)(null);
    const { items, observer, itemDataTestId, renderItem } = data;
    const item = items[index];
    (0, react_1.useLayoutEffect)(() => {
        const itemRefCurrent = itemRef.current;
        if (itemRefCurrent) {
            observer.observe(itemRefCurrent, index);
        }
        return () => {
            if (itemRefCurrent) {
                observer.unobserve(itemRefCurrent, index);
            }
        };
    }, [observer, index]);
    return (react_1.default.createElement("div", { "data-testid": itemDataTestId, key: index, style: style }, renderItem(item, itemRef, index)));
}
const innerElementStyles = (0, emotion_1.css)({
    position: 'relative',
});
const InnerElementType = (0, react_1.forwardRef)(function InnerElementType({ style, ...rest }, ref) {
    return (react_1.default.createElement("div", { "data-testid": "virtual-list-inner-container", className: innerElementStyles, ref: ref, style: style, ...rest }));
});
//# sourceMappingURL=virtual-list.js.map