import React from 'react';
import type { glyphs } from '@leafygreen-ui/icon';
export declare const scrollbarThumbLightTheme: string;
export declare const scrollbarThumbDarkTheme: string;
type WorkspaceTabsProps = {
    'aria-label': string;
    onCreateNewTab: () => void;
    onSelectTab: (tabIndex: number) => void;
    onSelectNextTab: () => void;
    onSelectPrevTab: () => void;
    onCloseTab: (tabIndex: number) => void;
    onMoveTab: (oldTabIndex: number, newTabIndex: number) => void;
    tabs: TabProps[];
    selectedTabIndex: number;
};
export type TabProps = {
    id: string;
    type: string;
    title: string;
    tooltip?: [string, string][];
    connectionId?: string;
    iconGlyph: Extract<keyof typeof glyphs, string> | 'Logo' | 'Server';
} & Omit<React.HTMLProps<HTMLDivElement>, 'id' | 'title'>;
export declare function useRovingTabIndex<T extends HTMLElement = HTMLElement>({ currentTabbable, }: {
    currentTabbable: number;
}): React.HTMLProps<T>;
declare function WorkspaceTabs({ ['aria-label']: ariaLabel, onCreateNewTab, onCloseTab, onMoveTab, onSelectTab, onSelectNextTab, onSelectPrevTab, tabs, selectedTabIndex, }: WorkspaceTabsProps): JSX.Element;
export { WorkspaceTabs };
//# sourceMappingURL=workspace-tabs.d.ts.map