"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEffectOnChange = void 0;
const react_1 = require("react");
const react_2 = require("react");
const kValueChanged = Symbol('Value changed');
function useMemoDependencies(value) {
    return (0, react_1.useMemo)(() => {
        return Array.isArray(value) ? value : [value];
    }, Array.isArray(value) ? value : [value]);
}
function useEffectOnChange(fn, val) {
    const initial = (0, react_2.useRef)(val);
    const effect = (0, react_2.useRef)(fn);
    effect.current = fn;
    (0, react_2.useEffect)(() => {
        if (val !== initial.current) {
            initial.current = kValueChanged;
            return effect.current();
        }
    }, useMemoDependencies(val));
    return (0, react_2.useRef)(val);
}
exports.useEffectOnChange = useEffectOnChange;
//# sourceMappingURL=use-effect-on-change.js.map